## afni 0.20141224~dfsg.1

=== debian/changelog ===
afni (0.20141224~dfsg.1-1~nd60+1) squeeze; urgency=low

  * Backported for squeeze.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Thu, 25 Dec 2014 12:13:09 -0500

afni (0.20141224~dfsg.1-1) neurodebian; urgency=medium

  * Fresh upstream code
  * debian/patches -- 1 updated

 -- Yaroslav Halchenko <debian@onerussian.com>  Thu, 25 Dec 2014 11:33:53 -0500

afni (0.20141212~dfsg.1-1) neurodebian; urgency=medium

  * New upstream code
  * debian/patches
    - refreshed all
    - cmake_tests: allow for "Out of Cheese Error"

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 15 Dec 2014 20:14:24 -0500

afni (0.20141118~dfsg.1-1) neurodebian; urgency=medium

  * New upstream code
  * debian/patches
    - cmake_sharedlibs  was split into two (-noncmake and -cmake) with
      cmake files being only in -cmake one while -noncmake containing sattelite
      patches
    - cmake_sharedlibs-cmake  updated for introduced few new files

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 21 Nov 2014 16:26:20 -0500

afni (0.20141107~dfsg.1-1) neurodebian; urgency=medium

  * New upstream code
  * debian/patches
    - updated for changes in upstream code (new sources, one patch was adopted)

 -- Yaroslav Halchenko <debian@onerussian.com>  Thu, 13 Nov 2014 11:02:42 -0500

afni (0.20140910~dfsg.1-1) neurodebian; urgency=medium

  * debian/patches
    - accounted for added roiing.* files
    - accounted for renames/new python mvm scripts
    - accounted in AFNIio.R for the rename R_io.so -> librio.so in our build

 -- Yaroslav Halchenko <debian@onerussian.com>  Sun, 12 Oct 2014 17:00:23 -0400
